/*
  This file is part of GerQUtils.

  GerQUtils is free software: you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation, either version 3 of the License, or (at your option) any later
  version.

  GerQUtils is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  GerQUtils.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef GERQ_EXCEPTION_H
#define GERQ_EXCEPTION_H


#include <exception>


namespace GerQ {


  class Exception: public std::exception {

    public:

      Exception(const char* aWhat);
      virtual ~Exception() throw();

      virtual const char* what() const throw();

    private:

      char *fWhat;

  }; // Exception


  class ExcBadFileAccess: public Exception {

    public:

      ExcBadFileAccess(const char* aWhat): Exception(aWhat) {}

  }; // ExcBadFileAccess


  class ExcKeyCollision: public Exception {

    public:

      ExcKeyCollision(const char* aWhat): Exception(aWhat) {}

  }; // ExcKeyCollision


} // GerQ


#endif
